<?php

$wpconfig = realpath("../../../../wp-config.php");

if (!file_exists($wpconfig)) {
	echo "Could not found wp-config.php. Error in path :\n\n".$wpconfig ;	
	die;	
}// stop when wp-config is not there

require_once($wpconfig);
require_once(ABSPATH.'/wp-admin/admin.php');

// check for rights
if(!current_user_can('edit_posts')) die;

global $wpdb;

//The nonce value
$nonce = wp_create_nonce('mudslide');

if(!function_exists('minimax_version') || minimax_version()<MUDS_MNMX_V) {
	printf(__('You have to install <a href="%s" target="_BLANK">minimax %1.1f</a> in order for this plugin to work.', 'mudslide'), "http://wordpress.org/extend/plugins/minimax/", MUDS_MNMX_V );
	exit(); 
}

?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
	<title>MudSlideShow</title>
	<meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
	<script language="javascript" type="text/javascript" src="<?php echo get_option('siteurl') ?>/wp-includes/js/tinymce/tiny_mce_popup.js"></script>
	<script language="javascript" type="text/javascript" src="<?php echo get_option('siteurl') ?>/wp-includes/js/tinymce/utils/mctabs.js"></script>
	<script language="javascript" type="text/javascript" src="<?php echo get_option('siteurl') ?>/wp-includes/js/tinymce/utils/form_utils.js"></script>
	<script language="javascript" type="text/javascript" src="<?php echo get_option('siteurl') ?>/wp-includes/js/tinymce/utils/form_utils.js"></script>
	<script language="javascript" type="text/javascript" src="<?php echo muds_plugin_url('/tinymce/mudslide.js'); ?>"></script>
	<?php minimax_header(); 
	$user_picasa = mudsPicasa_get_user(); 
	$user_flickr = mudsFlickr_get_user();
	$last_source = $options['last_source'];
	if(strlen($last_source)==0) $last_source=MUDS_TYPE_PICASA;
	
	$size_flickr = array("s", "t", "m", "l" );
	$size_picasa = array("64", "64c", "72", "72c", "144", "144c", "160", "160c", "200", "288", "320", "400", "512", "576", "640", "720", "800", "912","1024", "1152", "1280", "1440", "1660");
	
	$size_options="";
	
	switch($last_source) {
		case MUDS_TYPE_PICASA:
			$user_name = $user_picasa;
			foreach($size_picasa as $size) {
				$size_options.="<option value='$size'>$size</option>";
			}
			break;
		case MUDS_TYPE_FLICKR:
			$user_name = $user_flickr;
			foreach($size_flickr as $size) {
				$size_options.="<option value='$size'>$size</option>";
			}
			break;
	}
	
	$gallerylist = null;
	if(strlen($user_name)>0) {
		switch($last_source) {
			case MUDS_TYPE_FLICKR:
				$gallerylist = mudsFlickr_list_user_galleries($user_name);
				break;
			case MUDS_TYPE_PICASA:
				$gallerylist = mudsPicasa_list_user_galleries($user_name);
				break;
		}
	}
	
	?>
	<script language="javascript" type="text/javascript">
		/* <![CDATA[ */
		
		var user_picasa = '<?php echo $user_picasa; ?>';
		var user_flickr = '<?php echo $user_flickr; ?>';
		var last_source = <?php echo $last_source; ?>;
		
		var loading_img = new Image(); 
		loading_img.src = 'loading.gif';
		
		var mnmx = new minimax("<?php echo muds_plugin_url('/ajax/data.php'); ?>", false);
		//mnmx.setThrobber('Throbber3', 'on', 'off');
		
		var size_flickr = new Array("<?php echo implode('","', $size_flickr); ?>");
		var size_picasa = new Array("<?php echo implode('","', $size_picasa); ?>");
		
		function mudslide_changeSource(new_source) {
			last_source = new_source;
			var sourcetype1 = document.getElementsByName('sourcetype1')[0];
			var sourcetype2 = document.getElementsByName('sourcetype2')[0];
			var sourcetype3 = document.getElementsByName('sourcetype3')[0];
			var simplesize = document.getElementById('simplesize');
			var imgsize = document.getElementById('imgsize');
			var size_list = new Array();
			
			switch(last_source) {
				case '1': //Picasa
					size_list = size_picasa;
					break;
				case '2': //Flickr
					size_list = size_flickr;
					break;
			}
			
			simplesize.length=0;
			imgsize.length=0;
			for(var j in size_list) {
				simplesize.options[j]=new Option(size_list[j], size_list[j], false, false);
				imgsize.options[j]=new Option(size_list[j], size_list[j], false, false);
			}
			
			var list = new Array("Picasa", "Flickr");
			sourcetype1.length=0;
			sourcetype2.length=0;
			sourcetype3.length=0;
			for(var i in list) {
				val = (i*1)+1;
				if(val==last_source) {
					sourcetype1.options[i]=new Option(list[i], val, true, true);
					sourcetype2.options[i]=new Option(list[i], val, true, true);
					sourcetype3.options[i]=new Option(list[i], val, true, true);
				} else {
					sourcetype1.options[i]=new Option(list[i], val, false, false);
					sourcetype2.options[i]=new Option(list[i], val, false, false);
					sourcetype3.options[i]=new Option(list[i], val, false, false);
				}
			}			
			
			switch(new_source) {
					case '<?php echo MUDS_TYPE_PICASA; ?>':
						last_source = <?php echo MUDS_TYPE_PICASA; ?>;
						mudslide_changeUser(user_picasa);
						mudslide_UpdateUser(user_picasa,false);
						break;
					case '<?php echo MUDS_TYPE_FLICKR; ?>':
						last_source = <?php echo MUDS_TYPE_FLICKR; ?>;
						mudslide_changeUser(user_flickr);
						mudslide_UpdateUser(user_flickr,false);
						break;
					}
		} 
		
		function mudslide_changeUser(user) {
			var user_name = document.getElementById('user_name1');
			user_name.value=user;
			
			user_name = document.getElementById('user_name2');
			user_name.value=user;
			
			user_name = document.getElementById('user_name3');
			user_name.value=user;
		}

		var funcCheck = function() { 
			if (mnmx.xhr.readyState == 4 && mnmx.xhr.status==200 ) {
				var data=mnmx.xhr.responseText;
				
				mudslide_changeUser(data);
				mudslide_UpdateUser(data,false);
				
				switch(last_source) {
					case <?php echo MUDS_TYPE_PICASA; ?>:
						user_picasa=data;
						break
					case <?php echo MUDS_TYPE_FLICKR; ?>:
						user_flickr=data;
						break
				}
			}
		}
		
		var funcUser = function() { 
			if (mnmx.xhr.readyState == 4 && mnmx.xhr.status==200 ) {
				var data=mnmx.xhr.responseText;

				try { //IE
					xmldoc = new ActiveXObject("Microsoft.XMLDOM");
					xmldoc.async = "false";
					xmldoc.loadXML(data);
				} catch(e) {
					parser=new DOMParser();
					var xmldoc=parser.parseFromString(data,"text/xml");
				}

				var gallerypictag = document.getElementById('gallerypictag');
				gallerypictag.length=0;
				gallerypictag.options[0]=new Option('<?php _e("Select gallery", 'mudslide'); ?>', 0, false, false);

				var singlepictag = document.getElementById('singlepictag');
				singlepictag.length=0;
				singlepictag.options[0]=new Option('<?php _e("Select gallery first", 'mudslide'); ?>', 0, false, false);

				var gallerytag = document.getElementById('gallerytag');
				gallerytag.length=0;
				gallerytag.options[0]=new Option('<?php _e("Select gallery", 'mudslide'); ?>', 0, false, false);

				var simplegallerytag = document.getElementById('simplegallerytag');
				simplegallerytag.length=0;
				simplegallerytag.options[0]=new Option('<?php _e("Select gallery", 'mudslide'); ?>', 0, false, false);

				var albums = xmldoc.getElementsByTagName('album');
				for (i = 0; i < albums.length; i++) {
					var id = albums[i].childNodes[0].firstChild.nodeValue;
					var name = albums[i].childNodes[1].firstChild.nodeValue;
					gallerytag.options[i+1]=new Option(name, id, false, false)
					gallerypictag.options[i+1]=new Option(name, id, false, false)
					simplegallerytag.options[i+1]=new Option(name, id, false, false)
				}			
				mnmx.closeThrobber();
			}
		}

		var funcAlbum = function() { 
			if (mnmx.xhr.readyState == 4 && mnmx.xhr.status==200 ) {
				var data=mnmx.xhr.responseText;

				try { //IE
					xmldoc = new ActiveXObject("Microsoft.XMLDOM");
					xmldoc.async = "false";
					xmldoc.loadXML(data);
				} catch(e) {
					parser=new DOMParser();
					var xmldoc=parser.parseFromString(data,"text/xml");
				}

				var singlepictag = document.getElementById('singlepictag');
				singlepictag.length=0;
				var photos = xmldoc.getElementsByTagName('photo');
				for (i = 0; i < photos.length; i++) {
					var name = photos[i].childNodes[0].firstChild.nodeValue;
					singlepictag.options[i]=new Option(name, i, false, false)
				}
				mnmx.closeThrobber();
			}
		}
		
		function mudslide_CheckUser(user,update) {
			if(update) update=1;
			else update=0;
			if(last_source==<?php echo MUDS_TYPE_PICASA; ?>) type='picasa';
			else type='flickr'; 
			post = "nonce=<?php echo $nonce; ?>&amp;type="+type+"&amp;kind=check&amp;update="+update+"&amp;user="+user;
			mnmx.setFunc(funcCheck);
			mnmx.post(post); 
		}
				
		function mudslide_UpdateUser(user,update) {
			if(update) update=1;
			else update=0;
			if(last_source==<?php echo MUDS_TYPE_PICASA; ?>) type='picasa';
			else type='flickr';
			post = "nonce=<?php echo $nonce; ?>&amp;type="+type+"&amp;kind=galleries&amp;update="+update+"&amp;user="+user;
			mnmx.setFunc(funcUser);
			mnmx.post(post); 
		}
				
		function mudslide_UpdateAlbum(user,gallery,update) {
			if(update) update=1;
			else update=0;
			if(last_source==<?php echo MUDS_TYPE_PICASA; ?>) type='picasa';
			else type='flickr';
			post = "nonce=<?php echo $nonce; ?>&amp;type="+type+"&amp;kind=gallery&amp;update="+update+"&amp;user="+user+"&amp;gallery="+gallery;
			mnmx.setFunc(funcAlbum)
			mnmx.post(post); 
		}
	/* ]]> */		
	</script>
	<style type="text/css">

		img.on {
		height: 20px;
		background: url('<?php echo muds_plugin_url('/img/th-loading.gif'); ?>') center center;
		cursor: pointer;
		vertical-align: middle;
	}


	img.off {
		height: 20px;
		background: url('<?php echo muds_plugin_url('/img/th-update.gif'); ?>') center center;
		cursor: pointer;
		vertical-align: middle;
	}
		
	</style>
	<base target="_self" />
</head>
<body id="link" onload="tinyMCEPopup.executeOnLoad('init();');document.body.style.display='';document.getElementById('gallerytag').focus();" style="display: none">
<!-- <form onsubmit="insertLink();return false;" action="#"> -->
	<form name="MudSlide" action="#">
	<div class="tabs">
		<ul>
			<li id="gallery_tab" class="current"><span><a href="javascript:mcTabs.displayTab('gallery_tab','gallery_panel');" onmousedown="return false;"><?php _e("Gallery", 'mudslide'); ?></a></span></li>
			<li id="simplegallery_tab"><span><a href="javascript:mcTabs.displayTab('simplegallery_tab','simplegallery_panel');" onmousedown="return false;"><?php _e("Simple Gallery", 'mudslide'); ?></a></span></li>
			<li id="singlepic_tab"><span><a href="javascript:mcTabs.displayTab('singlepic_tab','singlepic_panel');" onmousedown="return false;"><?php _e("Picture", 'mudslide'); ?></a></span></li>
		</ul>
	</div>
	
	<div class="panel_wrapper" style="height: 170px;">
		<!-- gallery panel -->
		<div id="gallery_panel" class="panel current">
		<br />
		<table border="0" cellpadding="4" cellspacing="0">
			<tr>
				<td nowrap="nowrap"><label for="sourcetype1"><?php _e("Source", 'mudslide'); ?></label></td>
				<td><select id="sourcetype1" name="sourcetype1" onchange="mnmx.setThrobber('Throbber_user1', 'on', 'off');  mudslide_changeSource(this.value);">
						<option value="<?php echo MUDS_TYPE_PICASA; ?>"<?php if($last_source==MUDS_TYPE_PICASA) echo "selected"; ?>>Picasa</option>
						<option value="<?php echo MUDS_TYPE_FLICKR; ?>"<?php if($last_source==MUDS_TYPE_FLICKR) echo "selected"; ?>>Flickr</option>
					</select></td>
			</tr>
			<tr>
				<td nowrap="nowrap"><label for="gallerytag"><?php _e("User", 'mudslide'); ?></label></td>
				<td><input type="text" value="<?php echo $user_name; ?>" id="user_name1" onkeypress="
				if(window.event)
					key = window.event.keyCode; //IE
				else
					key = event.keyCode;
				if(key==13) {
					var gallerytag = document.getElementById('gallerytag');
					gallerytag.focus();
					return false;
				}" onchange="mnmx.setThrobber('Throbber_user1', 'on', 'off'); mudslide_CheckUser(this.value,false);"> <a href="http://wordpress.org/extend/plugins/mudslideshow/faq/" target="_BLANK"><img src="<?php echo muds_plugin_url('/img/question.png'); ?>" title="<?php _e('When in doubt, use your email as username.', 'mudslide'); ?>" border="0"></a></td>
			</tr>
			<tr valign="middle">
				<td nowrap="nowrap"><label for="gallerytag"><?php _e("Gallery", 'mudslide'); ?></label></td>
				<td><select id="gallerytag" name="gallerytag" style="width: 200px">
						<option value="0"><?php _e("Select gallery", 'mudslide'); ?></option>
						<?php
							if(strlen($user_name)>0) {
								if(is_array($gallerylist)) {
									foreach($gallerylist as $gallery) {
										echo '<option value="'.$gallery['id'].'" >'.$gallery['title'].'</option>'."\n";
									}
								}
							}
						?>
					</select> <a onclick="mnmx.setThrobber('Throbber_user1', 'on', 'off'); mnmx.activateThrobber(); mudslide_CheckUser(document.getElementById('user_name1').value,true);"><img id="Throbber_user1" class="off" src="<?php echo muds_plugin_url('/img/th-mask.gif'); ?>" border="0"></a></td>
			</tr>
		</table>
		</div>
		<!-- gallery panel -->
						
		<!-- mudsimple panel -->
		<div id="simplegallery_panel" class="panel">
			<br />
			<table border="0" cellpadding="4" cellspacing="0">
				<tr>
				<td nowrap="nowrap"><label for="sourcetype2"><?php _e("Source", 'mudslide'); ?></label></td>
				<td><select id="sourcetype2" name="sourcetype2" onchange="mnmx.setThrobber('Throbber_user2', 'on', 'off');  mudslide_changeSource(this.value);">
						<option value="<?php echo MUDS_TYPE_PICASA; ?>"<?php if($last_source==MUDS_TYPE_PICASA) echo "selected"; ?>>Picasa</option>
						<option value="<?php echo MUDS_TYPE_FLICKR; ?>"<?php if($last_source==MUDS_TYPE_FLICKR) echo "selected"; ?>>Flickr</option>
					</select></td>
			</tr>
				<tr>
					<td nowrap="nowrap"><label for="simplegallerytag"><?php _e("User", 'mudslide'); ?></label></td>
					<td><input type="text" value="<?php echo $user_name; ?>" id="user_name2" onkeypress="
					if(window.event)
						key = window.event.keyCode; //IE
					else
						key = event.keyCode;
					if(key==13) {
						var simplegallerytag = document.getElementById('simplegallerytag');
						simplegallerytag.focus();
						return false;
					}" onchange="mnmx.setThrobber('Throbber_user2', 'on', 'off'); mudslide_CheckUser(this.value,false);"> <a href="http://wordpress.org/extend/plugins/mudslideshow/faq/" target="_BLANK"><img src="<?php echo muds_plugin_url('/img/question.png'); ?>" title="<?php _e('When in doubt, use your email as username.', 'mudslide'); ?>" border="0"></a></td>
				</tr>
				<tr valign="middle">
					<td nowrap="nowrap"><label for="simplegallerytag"><?php _e("Gallery", 'mudslide'); ?></label></td>
					<td><select id="simplegallerytag" name="simplegallerytag" style="width: 200px">
							<option value="0"><?php _e("Select gallery", 'mudslide'); ?></option>
							<?php
								if(strlen($user_name)>0) {
									if(is_array($gallerylist)) {
										foreach($gallerylist as $gallery) {
											echo '<option value="'.$gallery['id'].'" >'.$gallery['title'].'</option>'."\n";
										}
									}
								}
							?>
						</select> <a src="update.png" style="cursor : pointer;" onclick="mnmx.setThrobber('Throbber_user2', 'on', 'off'); mudslide_CheckUser(document.getElementById('user_name2').value,true);"><img border="0" id="Throbber_user2" class="off" src="<?php echo muds_plugin_url('/img/th-mask.gif'); ?>"></a></td>
				</tr>
				<tr>
					<td nowrap="nowrap" valign="top"><?php _e("Size", 'mudslide'); ?></td>
					<td>
						<label>
							<select id="simplesize" name="simplesize"><?php echo $size_options; ?></select>
						</label>
					</td>
				</tr>
				<tr>
					<td nowrap="nowrap" valign="top"><?php _e("Float", 'mudslide'); ?></td>
					<td>
						<label><select id="simplefloat" name="simplefloat">
							<option value="left"><?php _e("Left", 'mudslide'); ?></option>
							<option value="right"><?php _e("Right", 'mudslide'); ?></option>
							<option value="center"><?php _e("Center", 'mudslide'); ?></option>
						</select></label>
					</td>
				</tr>
			</table>
		</div>
		<!-- mudsimple panel -->
		
		<!-- single pic panel -->
		<div id="singlepic_panel" class="panel">
		<br />
		<table border="0" cellpadding="4" cellspacing="0">
			<tr>
				<td nowrap="nowrap"><label for="sourcetype3"><?php _e("Source", 'mudslide'); ?></label></td>
				<td><select id="sourcetype3" name="sourcetype3" onchange="mnmx.setThrobber('Throbber_user3', 'on', 'off');  mudslide_changeSource(this.value);">
						<option value="<?php echo MUDS_TYPE_PICASA; ?>"<?php if($last_source==MUDS_TYPE_PICASA) echo "selected"; ?>>Picasa</option>
						<option value="<?php echo MUDS_TYPE_FLICKR; ?>"<?php if($last_source==MUDS_TYPE_FLICKR) echo "selected"; ?>>Flickr</option>
					</select></td>
			</tr>
			<tr>
				<td nowrap="nowrap"><label for="gallerytag"><?php _e("User", 'mudslide'); ?></label></td>
				<td><input type="text" value="<?php echo $user_name; ?>" id="user_name3" onkeypress="
				if(window.event)
					key = window.event.keyCode; //IE
				else
					key = event.keyCode;
				if(key==13) {
					var gallerypictag = document.getElementById('gallerypictag');
					gallerypictag.focus();
					return false;
				}" onchange="mnmx.setThrobber('Throbber_user3', 'on', 'off'); mudslide_CheckUser(this.value,false);"> <a href="http://wordpress.org/extend/plugins/mudslideshow/faq/" target="_BLANK"><img src="<?php echo muds_plugin_url('/img/question.png'); ?>" title="<?php _e('When in doubt, use your email as username.', 'mudslide'); ?>" border="0"></a></td>
			</tr>
			<tr>
				<td nowrap="nowrap"><label for="gallerypictag"><?php _e("Gallery", 'mudslide'); ?></label></td>
				<td><select id="gallerypictag" name="gallerypictag" style="width: 200px" onchange="mnmx.setThrobber('Throbber_album3', 'on', 'off'); mudslide_UpdateAlbum(document.getElementById('user_name3').value,this.value,false);">
						<option value="0"><?php _e("Select gallery", 'mudslide'); ?></option>
						<?php
							if(strlen($user_name)>0) {
								if(is_array($gallerylist)) {
									foreach($gallerylist as $gallery) {
										echo '<option value="'.$gallery['id'].'" >'.$gallery['title'].'</option>'."\n";
									}
								}
							}
						?>
					</select> <a src="update.png" style="cursor : pointer;" onclick="mnmx.setThrobber('Throbber_user3', 'on', 'off'); mudslide_CheckUser(document.getElementById('user_name3').value,true);"><img border="0" id="Throbber_user3" class="off" src="<?php echo muds_plugin_url('/img/th-mask.gif'); ?>"></a></td>
			</tr>
			<tr>
				<td nowrap="nowrap"><label for="singlepictag"><?php _e("Picture", 'mudslide'); ?></label></td>
				<td><select id="singlepictag" name="singlepictag" style="width: 200px">
						<option value="0"><?php _e("Select gallery first", 'mudslide'); ?></option>
					</select> <a src="update.png" style="cursor : pointer;" onclick="mnmx.setThrobber('Throbber_album3', 'on', 'off'); mudslide_UpdateAlbum(document.getElementById('user_name3').value,document.getElementById('gallerypictag').value,true);"><img border="0" id="Throbber_album3" class="off" src="<?php echo muds_plugin_url('/img/th-mask.gif'); ?>"></a></td>
			</tr>
			<tr>
				<td nowrap="nowrap" valign="top"><?php _e("Size", 'mudslide'); ?></td>
				<td>
					<label>
						<select id="imgsize" name="imgsize"><?php echo $size_options; ?></select>
					</label>
				</td>
			</tr>
			<tr>
				<td nowrap="nowrap" valign="top"><?php _e("Float", 'mudslide'); ?></td>
				<td>
					<label><select id="imgfloat" name="imgfloat">
						<option value="left"><?php _e("Left", 'mudslide'); ?></option>
						<option value="right"><?php _e("Right", 'mudslide'); ?></option>
						<option value="center"><?php _e("Center", 'mudslide'); ?></option>
					</select></label>
				</td>
			</tr>
		</table>
		</div>
		<!-- single pic panel -->		
	</div>

	<div class="mceActionPanel">
		<div style="float: left">
			<input type="button" id="cancel" name="cancel" value="<?php _e("Cancel", 'mudslide'); ?>" onclick="tinyMCEPopup.close();" />
		</div>

		<div style="float: right">
			<input type="submit" id="insert" name="insert" value="<?php _e("Insert", 'mudslide'); ?>" onclick="insertMudSlideLink();" />
		</div>
	</div>
</form>
</body>
</html>
