<?php

/**
* Function to write the data needed in the header by highslide.
*
* @access public
*/
function muds_header() {
	require('highslide-header.php');
}

/**
* Function to write the data needed in the footer by highslide.
*
* @access public
*/
function muds_footer() {
	require('highslide-footer.php');
}

/**
* This function returns the html code to show an image using highslide as the viewer
*
* @access public
* @param url image The url to the big one.
* @param url image The url to the thumbnail. 
* @param string title The title of the image.
* @param int album If this image is part of an album we need a common number for this group.
* @param string float Is this image floating to the left, right or center?
* @param string comment Do this image have a comment? Send false if we don't have to show the comment.
* @param int size The size of the thumbnail.
* @return string The HTML code
*/
function muds_show($image, $thumbnail, $title, $album=0, $float='center', $comment=false, $size=200, $url, $type,  $width=false, $height=false) {
	$options=get_option('muds_options');
	$muds_showlink=$options['show_link'];
	
	$class = 'class="slideimg"';
	$class_float="";
	$center="";
	if($float=='center') $class_center=" align=\"center\"";
	$rand = mt_rand(111111,999999);
	
	//HTML specialchars
	$title = mb_htmlentities($title);
	if($comment) $comment = mb_htmlentities($comment);
	
	//The link to the photo source
	$link = "";
	switch($type) {
		case MUDS_TYPE_PICASA:
			$link = "<a href='$url' target='_blank'>".sprintf(__('Open in %s', 'mudslide'), 'Picasa')."</a>";
			break;
		case MUDS_TYPE_FLICKR:
			$link = "<a href='$url' target='_blank'>".sprintf(__('Open in %s', 'mudslide'), 'Flickr')."</a>";
			break;
		default:
			$link="";
			break;
	}
	
	$caption=$title;
	if($muds_showlink && $url) $caption="<div class='muds-title'>$caption</div><div class='muds-link'>$link</div>";
	$caption_side="";
	if($comment) {
		$vote = "";
		if(function_exists('dmkti_image')) {
			if($type == MUDS_TYPE_NONE) {
				$vote = dmkti_image($image, $title, $comment, $mini);
			} else {
				$vote = dmkti_image($url, $title, $comment, $mini);
			}
			$vote = "<br>$vote";
		}
		$caption=apply_filters('comment_text', "<div class='comments'><h3>".$title."</h3>".$comment.$vote."</div>");
		if($muds_showlink) $caption.="<div class='muds-link' align='right'>$link</div>";
		$caption_side= "captionOverlay: { position: 'rightpanel', width: '320px'},";
	}
	
	$max_width = "";
	$dim = "";
	if($width && $height) {
		$dim = " width='$width' height='$height'";
	} else {
		if($size) $max_width = 'style="max-width: '.$size.'px;"';
		$side = "";
	}
	
	/*$img = '<a id="thumb'.$rand.'" href="'.$image.'" onclick="return hs.expand(this, { '.$caption_side.' captionId: \'mudscaption'.$rand.'\', slideshowGroup: \''.$album.'\' } )" class="highslide"><img '.$class.$dim.' alt="MSS" title="'.$title.'" src="'.$thumbnail.'" border="0" '.$max_width.'/></a><div class="highslide-caption" id="mudscaption'.$rand.'">'.$caption.'</div>';
	return "<div class=\"slide$float\"".$class_center.">$img</div>";*/

	$img = '<div class="slideborder slide'.$float.'">
			<a id="thumb'.$rand.'" class="mssfb-image highslide" target="_self" href="'.$image.'" rel="lytebox['.$album.']" title="'.$title.'" onmouseover="document.getElementById(\'slidecontainer'.$rand.'\').style.visibility=\'visible\';" onmouseout="document.getElementById(\'slidecontainer'.$rand.'\').style.visibility=\'hidden\';" onclick="return hs.expand(this, { '.$caption_side.' captionId: \'mudscaption'.$rand.'\', slideshowGroup: \''.$album.'\' } )">
				<div class="slideext">
					<img '.$dim.' alt="'.$short.'" title="'.$short.'" src="'.$thumbnail.'" border="0" '.$max_width.'/>
					<div id="slidecontainer'.$rand.'" class="slidecontainer" title="'.$short.'"></div>
				</div>
			</a><div class="highslide-caption" id="mudscaption'.$rand.'">'.$caption.'</div>
		</div>';
	return muds_general($img,$float);
}

?>
